package fr.cnam.connecteur;

import java.util.*;
import java.rmi.*;
import java.rmi.server.*;

public class ConnecteurClient extends UnicastRemoteObject implements IConnecteurClient, INotifier
{
  private static ConnecteurClient connecteur=null;
  private IConnecteurServeur serveur;
  private ObservableClient observable;

  public ConnecteurClient(String host,int port,String name) throws Exception
  {
    try {
        serveur = (IConnecteurServeur)Naming.lookup("rmi://"+host+":"+port+"/"+name);
        serveur.connecter((IConnecteurClient)(RemoteObject.toStub(this)));
        this.observable = new ObservableClient();
      }
    catch(Exception ex)
      {
        serveur=null;
        this.observable = new ObservableClient();
        System.out.println("Le connecteur est utilise en LOCAL");
      }
  }

  public void push(Object any)
  {
    System.out.println("push");
    observable.setChanged();
    observable.notifyObservers(any);
  }

  public void notifier(Object any)
  {
    push(any);
  }
    
  public static ConnecteurClient getInstance()
  {
    if (connecteur==null) 
      try {
        connecteur = new ConnecteurClient("localhost",9100,"CONNECTEUR");
        return connecteur;
      }catch(Exception ex){return null;}
    else return connecteur;
  }

  public static void add(Observer obs)
    {
      ConnecteurClient.getInstance().getObservableClient().addObserver(obs);
    }
  
  public ObservableClient getObservableClient(){
    return observable; }
}