package fr.cnam.connecteur;

import java.util.*;
import java.rmi.*;
import java.rmi.server.*;
import java.rmi.registry.*;

public class ConnecteurServeur extends UnicastRemoteObject implements IConnecteurServeur, INotifier
{
  private ArrayList<IConnecteurClient> clients;

  public ConnecteurServeur(String name) throws Exception
  {
    super(9101);
    clients = new ArrayList<IConnecteurClient>();
    try{
      LocateRegistry.createRegistry(9100);
    } catch(Exception ex){};
        
    Naming.rebind("rmi://localhost:9100/"+name,this);
  }

  public void connecter(IConnecteurClient client) throws RemoteException
  {
    this.clients.add(client);
  }

  public void notifier(Object any)
  {
    try{
      System.out.println("notifier");
      for(IConnecteurClient c:clients) c.push(any);
    }catch(Exception ex){System.out.println(ex);}
  }

  public static INotifier creer(ConnecteurClient c)
  {
    if (c==null)
      {
        ConnecteurServeur csv = null;
        try{
          csv = new ConnecteurServeur("CONNECTEUR");
        }catch(Exception ex){System.out.println(ex);};
        return csv;
      }
    else
      {
        return c;
      }
  }

}

    