package fr.cnam.metier;

import java.util.*;
import fr.cnam.connecteur.*;
import fr.cnam.metier.*;

public class FactoryPersonne 
{
    private ArrayList<IPersonne> elements;
    private INotifier notifier;

    public FactoryPersonne(INotifier notifier)
    {
        elements = new ArrayList<IPersonne>();
        this.notifier = notifier;
    }

    public IPersonne creerPersonne(String nom,String prenom,String adresse)
    {
        IPersonne p = new ProxyPersonne(notifier,
                                        new Personne(nom,prenom,adresse));
        elements.add(p);
        return p;
    }

    public IPersonne get(int index)
    {
        return elements.get(index);
    }
    
    public void lister()
    {
        System.out.println("-------------------------------------------");
        int i=0;
        for(IPersonne p:elements)
            System.out.println(String.format("%2d %20s %20s %20s",
                                             i++,
                                             p.getNom(),
                                             p.getPrenom(),
                                             p.getAdresse()));
        System.out.println("-------------------------------------------");
    }

}


